import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { MerchantCategory, MerchantCategoryParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商家分类
 */
export async function pageMerchantCategory(params: MerchantCategoryParam) {
  const res = await request.get<ApiResult<PageResult<MerchantCategory>>>(
    MODULES_API_URL + '/shop/merchant-category/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商家分类列表
 */
export async function listMerchantCategory(params?: MerchantCategoryParam) {
  const res = await request.get<ApiResult<MerchantCategory[]>>(
    MODULES_API_URL + '/shop/merchant-category',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商家分类
 */
export async function addMerchantCategory(data: MerchantCategory) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商家分类
 */
export async function updateMerchantCategory(data: MerchantCategory) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-category',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商家分类
 */
export async function removeMerchantCategory(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-category/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商家分类
 */
export async function removeBatchMerchantCategory(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/merchant-category/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商家分类
 */
export async function getMerchantCategory(id: number) {
  const res = await request.get<ApiResult<MerchantCategory>>(
    MODULES_API_URL + '/shop/merchant-category/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
